---
title: Update MFA Settings
description: The operation PUT {{apiPath}}/v1/environments/{{envID}}/mfaSettings updates the MFA settings for an environment.
component: pingone-api
page_id: pingone-api:mfa:mfa-settings/update_mfa_settings_alphanumeric
canonical_url: https://developer.pingidentity.com/pingone-api/mfa/mfa-settings/update_mfa_settings_alphanumeric.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Update MFA Settings

##

```none
PUT {{apiPath}}/v1/environments/{{envID}}/mfaSettings
```

The operation `PUT {{apiPath}}/v1/environments/{{envID}}/mfaSettings` updates the MFA settings for an environment.

In this example, the following MFA settings are updated:

* Number of failures before lockout

* Lockout duration

* Maximum number of devices allowed per user

* The pairing key format to use

* Enabling of phone extensions

* Enabling of MFA by default for new users

### Prerequisites

* Refer to [MFA Settings](#mfa-settings) for important overview information.

> **Collapse: Request Model**
>
> | Property                    | Type    | Required? |
> | --------------------------- | ------- | --------- |
> | `lockout.failureCount`      | Integer | Optional  |
> | `lockout.durationSeconds`   | Integer | Optional  |
> | `pairing.maxAllowedDevices` | Integer | Optional  |
> | `pairing.pairingKeyFormat`  | String  | Optional  |
> | `phoneExtensions.enabled`   | Boolean | Optional  |
> | `users.mfaEnabled`          | Boolean | Optional  |
>
> Refer to the [MFA Settings data model](#mfa-settings-data-model) for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "pairing": {
        "maxAllowedDevices": 10,
        "pairingKeyFormat": "ALPHANUMERIC"
    },
    "lockout":{
        "failureCount":6,
        "durationSeconds":1200
    },
    "phoneExtensions": {
        "enabled": true
    },
    "users":{
        "mfaEnabled": true
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PUT '{{apiPath}}/v1/environments/{{envID}}/mfaSettings' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "pairing": {
        "maxAllowedDevices": 10,
        "pairingKeyFormat": "ALPHANUMERIC"
    },
    "lockout":{
        "failureCount":6,
        "durationSeconds":1200
    },
    "phoneExtensions": {
        "enabled": true
    },
    "users":{
        "mfaEnabled": true
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/mfaSettings")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""pairing"": {" + "\n" +
@"        ""maxAllowedDevices"": 10," + "\n" +
@"        ""pairingKeyFormat"": ""ALPHANUMERIC""" + "\n" +
@"    }," + "\n" +
@"    ""lockout"":{" + "\n" +
@"        ""failureCount"":6," + "\n" +
@"        ""durationSeconds"":1200" + "\n" +
@"    }," + "\n" +
@"    ""phoneExtensions"": {" + "\n" +
@"        ""enabled"": true" + "\n" +
@"    }," + "\n" +
@"    ""users"":{" + "\n" +
@"        ""mfaEnabled"": true" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/mfaSettings"
  method := "PUT"

  payload := strings.NewReader(`{
    "pairing": {
        "maxAllowedDevices": 10,
        "pairingKeyFormat": "ALPHANUMERIC"
    },
    "lockout":{
        "failureCount":6,
        "durationSeconds":1200
    },
    "phoneExtensions": {
        "enabled": true
    },
    "users":{
        "mfaEnabled": true
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PUT /v1/environments/{{envID}}/mfaSettings HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "pairing": {
        "maxAllowedDevices": 10,
        "pairingKeyFormat": "ALPHANUMERIC"
    },
    "lockout":{
        "failureCount":6,
        "durationSeconds":1200
    },
    "phoneExtensions": {
        "enabled": true
    },
    "users":{
        "mfaEnabled": true
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"pairing\": {\n        \"maxAllowedDevices\": 10,\n        \"pairingKeyFormat\": \"ALPHANUMERIC\"\n    },\n    \"lockout\":{\n        \"failureCount\":6,\n        \"durationSeconds\":1200\n    },\n    \"phoneExtensions\": {\n        \"enabled\": true\n    },\n    \"users\":{\n        \"mfaEnabled\": true\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/mfaSettings")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/mfaSettings",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "pairing": {
      "maxAllowedDevices": 10,
      "pairingKeyFormat": "ALPHANUMERIC"
    },
    "lockout": {
      "failureCount": 6,
      "durationSeconds": 1200
    },
    "phoneExtensions": {
      "enabled": true
    },
    "users": {
      "mfaEnabled": true
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/v1/environments/{{envID}}/mfaSettings',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "pairing": {
      "maxAllowedDevices": 10,
      "pairingKeyFormat": "ALPHANUMERIC"
    },
    "lockout": {
      "failureCount": 6,
      "durationSeconds": 1200
    },
    "phoneExtensions": {
      "enabled": true
    },
    "users": {
      "mfaEnabled": true
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/mfaSettings"

payload = json.dumps({
  "pairing": {
    "maxAllowedDevices": 10,
    "pairingKeyFormat": "ALPHANUMERIC"
  },
  "lockout": {
    "failureCount": 6,
    "durationSeconds": 1200
  },
  "phoneExtensions": {
    "enabled": True
  },
  "users": {
    "mfaEnabled": True
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/mfaSettings');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "pairing": {\n        "maxAllowedDevices": 10,\n        "pairingKeyFormat": "ALPHANUMERIC"\n    },\n    "lockout":{\n        "failureCount":6,\n        "durationSeconds":1200\n    },\n    "phoneExtensions": {\n        "enabled": true\n    },\n    "users":{\n        "mfaEnabled": true\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/mfaSettings")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "pairing": {
    "maxAllowedDevices": 10,
    "pairingKeyFormat": "ALPHANUMERIC"
  },
  "lockout": {
    "failureCount": 6,
    "durationSeconds": 1200
  },
  "phoneExtensions": {
    "enabled": true
  },
  "users": {
    "mfaEnabled": true
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"pairing\": {\n        \"maxAllowedDevices\": 10,\n        \"pairingKeyFormat\": \"ALPHANUMERIC\"\n    },\n    \"lockout\":{\n        \"failureCount\":6,\n        \"durationSeconds\":1200\n    },\n    \"phoneExtensions\": {\n        \"enabled\": true\n    },\n    \"users\":{\n        \"mfaEnabled\": true\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/mfaSettings")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/mfaSettings"
        },
        "environment": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        }
    },
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "pairing": {
        "maxAllowedDevices": 10,
        "pairingKeyFormat": "ALPHANUMERIC"
    },
    "lockout": {
        "failureCount": 6,
        "durationSeconds": 1200
    },
    "authentication": {
        "deviceSelection": "DEFAULT_TO_FIRST"
    },
    "updatedAt": "2023-08-06T16:59:11.737Z",
    "phoneExtensions": {
        "enabled": true
    },
    "users": {
        "mfaEnabled": true
    }
}
```
